#include <gtk/gtk.h>
#include <gtkextra/gtkextra.h>
#include <Python.h>
#include <grammar.h>
#include <node.h>
#include <parsetok.h>
#include <errcode.h>
#include <compile.h>
#include <eval.h>
#include <marshal.h>
#ifdef WITH_NUMERIC_PYTHON
#include <arrayobject.h>
#endif
#include "../main.h"
#include "python_int.h"

extern PyObject *main_o, *dict_o;

int sg_eval_func(gchar *func_def, gdouble x_value, gdouble *y_value)
{ PyObject *object=NULL;
  gint len;

  object=Py_BuildValue("d",x_value);
  if (!object) return FALSE;
  PyDict_SetItemString (dict_o, "x", object);

  object=PyRun_String (func_def, Py_eval_input, dict_o, dict_o);
  if (!object)
   { if (PyErr_Occurred()) { PyErr_Print(); PyErr_Clear();}
     return FALSE;
   }

  *y_value=PyFloat_AsDouble (object);

  return TRUE;
}